#include <stddef.h>
#include <sysexits.h>
#include <unistd.h>
#include "libstrnum.h"

int *typenames[] = {
	(int []){ 'f','l','o','a','t', ASCII_US, STRIS_TYPE_FLOAT, '\0' },
	(int []){ 'i','n','t', ASCII_US, STRIS_TYPE_INT, '\0' },
	(int []){ 'u','i','n','t', ASCII_US, STRIS_TYPE_UINT, '\0' }
};

size_t typenames_s = 3;

int main(int argc, char *argv[]){
	int i;
	int j;
	int k;
	enum Strtype t;

	for(k = 0; argv[0][k] != '\0'; ++k);
	if(argc < 3){
		write(2, "Usage: ", 7);
		write(2, argv[0], k);
		write(2, " [type] [string...]\n", 20);
		return EX_USAGE;
	}

	j = 0;
	t = 0;
	for(i = 0; argv[1][i] != '\0'; ++i)
		if(typenames[j][i] != argv[1][i])
			if(++j >= typenames_s){
				write(2, argv[0], k);
				write(2, ": ", 2);
				for(k = 0; argv[1][k] != '\0'; ++k);
				write(2, argv[1], k);
				write(2, ": No such type\n", 15);
				return EX_DATAERR;
			}


	if(argv[1][i] == '\0' && typenames[j][i] == ASCII_US)
		t = typenames[j][i+1];

	for(i = 2; i < argc; ++i)
		if(!stris(t, argv[i]))
			return 1;

	return 0;
}
