#ifndef _STDBOOL_H
#	define _STDBOOL_H
#	define bool _Bool
#	define false 0
#	define true 1
#	define __bool_true_false_are_defined 1
/* "dirtbag boolean"
 * - ideally the compiler would keep all the booleans in [x] number of unsigned
 * [type]s so it could squeeze eight booleans out of one byte.
 * alas, the simplest thing tends to be best, and it's nice to not waste 20
 * cycles (figure made up) on applying a bitmask to an int to read a bool */
#	define _Bool unsigned char
#endif /* ifndef _STDBOOL_H */
