#include <stddef.h> /* NULL */
#include <sysexits.h> /* EX_USAGE */
#include <unistd.h> /* execv(3), write(2) */
#include "noargvzero.h"

int main(int argc, char *argv[]){
	int i;
	NOARGVZERO(argv);

	if(argc < 2){
		write(2, "Usage: ", 7);
		for(i = 0; argv[0][i] != '\0'; ++i);
		write(2, argv[0], i);
		write(2, " [pathname], [argv...]\n", 23);
		return EX_USAGE;
	}

	return execv(argv[1], argv+2);
}
