#include <stdlib.h> /* atoi(3) */
#include <sysexits.h> /* EX_USAGE */
#include <unistd.h> /* sleep(3) */
#include "libstris.h" /* stris(3) */
#include "noargvzero.h"

int main(int argc, char **argv){
	int s;
	NOARGVZERO(argv);
	if(argc != 2 || !stris(STRIS_TYPE_INT, argv[1])){
		write(2, "Usage: ", 7);
		for(s = 0; argv[0][s] != '\0'; ++s);
		write(2, argv[0], s);
		write(2, " [seconds]\n", 11);
		return EX_USAGE;
	}
	s = atoi(argv[1]);
	while(s > 0)
		s = sleep(s);
	return s;
}
